// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneComponent.hpp"

typedef uint32_t entityid_t;
typedef int64_t entitytileposition_t;

namespace Dawn {
  class World;

  enum class EntityDirection {
    Up,
    Down,
    Left,
    Right
  };

  class Entity : public SceneComponent {
    private:
      entitytileposition_t tileX = 0, tileY = 0, tileZ = 0;
      enum EntityDirection direction = EntityDirection::Down;
      float_t stepTime = 0.0f;

    protected:

    public:
      std::weak_ptr<World> world;
      
      void onInit() override;
      void onDispose() override;
      void move(const enum EntityDirection direction);
  };
}