// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "Player.hpp"
#include "scene/Scene.hpp"
#include "input/InputBinds.hpp"

using namespace Dawn;

void Player::onInit() {
  Entity::onInit();

  listeners.push_back(getScene()->onUnpausedUpdate.listen([this](float delta) {
    InputManager &im = getGame()->inputManager;
    if(im.isPressed(InputBind::Up)) {
      this->move(EntityDirection::Up);
    } else if(im.isPressed(InputBind::Down)) {
      this->move(EntityDirection::Down);
    } else if(im.isPressed(InputBind::Left)) {
      this->move(EntityDirection::Left);
    } else if(im.isPressed(InputBind::Right)) {
      this->move(EntityDirection::Right);
    }
  }));
}

void Player::onDispose() {
  Entity::onDispose();
}