// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "prefab/Prefab.hpp"
#include "component/world/World.hpp"
#include "component/display/MeshRenderer.hpp"
#include "component/display/material/SimpleTexturedMaterial.hpp"
#include "component/entity/Player.hpp"

namespace Dawn {
  struct PlayerPrefab : public Prefab {
    public:
      std::shared_ptr<Player> player;
      std::shared_ptr<Mesh> mesh;
      std::shared_ptr<MeshRenderer> meshRenderer;
      std::shared_ptr<SimpleTexturedMaterial> material;
  };

  struct PlayerPrefab createPlayerPrefab(const std::shared_ptr<World> world);
}